###################################################
### chunk number 1: 
###################################################
#line 63 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
library(CNVassoc)


###################################################
### chunk number 2: 
###################################################
#line 68 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
library(xtable)


###################################################
### chunk number 3: 
###################################################
#line 91 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
data(dataMLPA)
head(dataMLPA)


###################################################
### chunk number 4: 
###################################################
#line 110 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
par(mfrow=c(2,2),mar=c(3,4,3,1))
hist(dataMLPA$Gene1,main="Gene 1 signal histogram",xlab="",ylab="frequency")
hist(dataMLPA$Gene2,main="Gene 2 signal histogram",xlab="",ylab="frequency")
par(xaxs="i")
plot(density(dataMLPA$Gene1),main="Gene 1 signal density function",xlab="",ylab="density")
plot(density(dataMLPA$Gene2),main="Gene 2 signal density function",xlab="",ylab="density")


###################################################
### chunk number 5: 
###################################################
#line 125 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
plotSignal(dataMLPA$Gene2,case.control=dataMLPA$casco)


###################################################
### chunk number 6: 
###################################################
#line 131 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
plotSignal(dataMLPA$Gene2,case.control=dataMLPA$casco)


###################################################
### chunk number 7: 
###################################################
#line 140 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
plotSignal(dataMLPA$Gene2,case.control=dataMLPA$quanti)


###################################################
### chunk number 8: 
###################################################
#line 147 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
plotSignal(dataMLPA$Gene2,case.control=dataMLPA$quanti)


###################################################
### chunk number 9: 
###################################################
#line 185 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
cutpoints <- c(0.08470221, 0.40485249)


###################################################
### chunk number 10: 
###################################################
#line 188 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
cutpoints


###################################################
### chunk number 11: 
###################################################
#line 223 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
CNV.1<-cnv(x=dataMLPA$Gene1, threshold.0=0.06, num.class=3, mix.method = "mixdist")


###################################################
### chunk number 12: 
###################################################
#line 239 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
CNV.2<-cnv(x=dataMLPA$Gene2, threshold.0=0.01, mix.method = "mixdist")


###################################################
### chunk number 13: 
###################################################
#line 262 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
probs.2<-getProbs(CNV.2)


###################################################
### chunk number 14: 
###################################################
#line 272 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
CNV.2probs<-cnv(probs.2)


###################################################
### chunk number 15: 
###################################################
#line 283 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
CNV.2th<-cnv(x=dataMLPA$Gene2, cutoffs=cutpoints)


###################################################
### chunk number 16: 
###################################################
#line 297 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
CNV.1


###################################################
### chunk number 17: 
###################################################
#line 305 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
CNV.2


###################################################
### chunk number 18: 
###################################################
#line 313 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
CNV.2probs


###################################################
### chunk number 19: 
###################################################
#line 321 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
pdf("./figures/fig2a.pdf")
plot(CNV.1, case.control=dataMLPA$casco, main="Gene 1")
dev.off()
pdf("./figures/fig2b.pdf")
plot(CNV.2, case.control=dataMLPA$casco, main="Gene 2")
dev.off()


###################################################
### chunk number 20: 
###################################################
#line 360 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
plot(CNV.2probs, case.control=dataMLPA$casco)


###################################################
### chunk number 21: 
###################################################
#line 387 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
CNVassoc::getQualityScore(CNV.1,type="class")
CNVassoc::getQualityScore(CNV.2,type="class")


###################################################
### chunk number 22: 
###################################################
#line 396 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
CNVassoc::getQualityScore(CNV.1,type="CNVtools")
CNVassoc::getQualityScore(CNV.2,type="CNVtools")


###################################################
### chunk number 23: 
###################################################
#line 405 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
CNVassoc::getQualityScore(CNV.1,type="CANARY")
CNVassoc::getQualityScore(CNV.2,type="CANARY")


###################################################
### chunk number 24: 
###################################################
#line 444 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
model1mul<-CNVassoc(casco~CNV.1,data=dataMLPA,model="mul")
model2mul<-CNVassoc(casco~CNV.2,data=dataMLPA,model="mul")


###################################################
### chunk number 25: 
###################################################
#line 457 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
model1mul


###################################################
### chunk number 26: 
###################################################
#line 464 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
model2mul


###################################################
### chunk number 27: 
###################################################
#line 480 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
summary(model1mul)


###################################################
### chunk number 28: 
###################################################
#line 488 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
summary(model2mul)


###################################################
### chunk number 29: 
###################################################
#line 501 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
mod<-CNVassoc(quanti ~ CNV.2 + cov, family = "gaussian", data = dataMLPA, model = 'add', emsteps=10)
mod


###################################################
### chunk number 30: 
###################################################
#line 513 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
summary(mod)


###################################################
### chunk number 31: 
###################################################
#line 531 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
CNVtest(model1mul,type="Wald")
CNVtest(model1mul,type="LRT")


###################################################
### chunk number 32: 
###################################################
#line 540 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
CNVtest(model2mul,type="Wald")
CNVtest(model2mul,type="LRT")


###################################################
### chunk number 33: 
###################################################
#line 554 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
coef(summary(model1mul,ref=2))


###################################################
### chunk number 34: 
###################################################
#line 564 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
model2add<-CNVassoc(casco~CNV.2, data=dataMLPA, model="add")
model2add


###################################################
### chunk number 35: 
###################################################
#line 576 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
summary(model2add)


###################################################
### chunk number 36: 
###################################################
#line 590 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
anova(model2mul,model2add)


###################################################
### chunk number 37: 
###################################################
#line 638 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
data(NeveData)
intensities<-NeveData$data
pheno<-NeveData$pheno


###################################################
### chunk number 38: 
###################################################
#line 680 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
data(NeveCalled)


###################################################
### chunk number 39: 
###################################################
#line 690 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
probs<-getProbs(NeveCalled)


###################################################
### chunk number 40: 
###################################################
#line 698 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
probs[1:5,1:7]


###################################################
### chunk number 41: 
###################################################
#line 721 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
data(NeveRegions)


###################################################
### chunk number 42: 
###################################################
#line 729 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
probsRegions<-getProbsRegions(probs, NeveRegions, intensities)


###################################################
### chunk number 43: 
###################################################
#line 738 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
pvals<-multiCNVassoc(probsRegions, formula="pheno~CNV",
model="mult", num.copies=0:2, cnv.tol=0.01)


###################################################
### chunk number 44: 
###################################################
#line 750 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
pvalsBH<-getPvalBH(pvals)
head(pvalsBH)


###################################################
### chunk number 45: 
###################################################
#line 759 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
cumsum(table(cut(pvalsBH[,2],c(-Inf,1e-5,1e-4,1e-3,1e-2,0.05))))


###################################################
### chunk number 46: 
###################################################
#line 779 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
data(A112)


###################################################
### chunk number 47: 
###################################################
#line 783 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
head(A112)


###################################################
### chunk number 48: 
###################################################
#line 787 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
head(A112)


###################################################
### chunk number 49: 
###################################################
#line 802 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
library(CNVtools)


###################################################
### chunk number 50: 
###################################################
#line 812 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
raw.signal <- as.matrix(A112[, -c(1, 2)])
dimnames(raw.signal)[[1]] <- A112$subject


###################################################
### chunk number 51: 
###################################################
#line 818 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
pca.signal <- apply.pca(raw.signal)


###################################################
### chunk number 52: 
###################################################
#line 824 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
ncomp <- 3
batches <- factor(A112$cohort)
sample <- factor(A112$subject)
fit.pca <- CNVtest.binary(signal = pca.signal, sample = sample, batch = batches, ncomp = ncomp, n.H0 = 3, n.H1 = 0, model.var = "~ strata(cn)")


###################################################
### chunk number 53: 
###################################################
#line 832 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
pca.posterior <- as.matrix((fit.pca$posterior.H0)[, paste("P", seq(1:ncomp), sep = "")])
dimnames(pca.posterior)[[1]] <- (fit.pca$posterior.H0)$subject
ldf.signal <- apply.ldf(raw.signal, pca.posterior)


###################################################
### chunk number 54: 
###################################################
#line 848 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
CNV<-cnv(ldf.signal, batches=batches, num.class=3, mix="mclust")
CNV


###################################################
### chunk number 55: 
###################################################
#line 864 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
plot(CNV)


###################################################
### chunk number 56: 
###################################################
#line 883 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
trait <- ifelse(A112$cohort == "58C", 0, 1)
fit <- CNVassoc(trait ~ CNV, model = "add")
CNVtest(fit,"LRT")


###################################################
### chunk number 57: 
###################################################
#line 889 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
# by default CNVtest.binary assumes: model.var = "~ strata(batch, cn)", model.disease = "~ cn" (trend CNV effect, and different vars per batch).
fit.cnvtools <- CNVtest.binary(signal=ldf.signal,sample=sample,batch=batches,disease.status=trait,ncomp=ncomp,n.H0=3,n.H1=1,model.var="~cn")
chi.cnvtools  <-  -2*(fit.cnvtools$model.H0$lnL-fit.cnvtools$model.H1$lnL)


###################################################
### chunk number 58: 
###################################################
#line 899 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
fit <- CNVassoc(trait ~ CNV)
CNVtest(fit,"LRT")


###################################################
### chunk number 59: 
###################################################
#line 904 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
fit.cnvtools <- CNVtest.binary(signal=ldf.signal,sample=sample,batch=batches,disease.status=trait,ncomp=3,n.H0=3,n.H1=1,model.disease="~as.factor(cn)")
chi.cnvtools  <-  -2*(fit.cnvtools$model.H0$lnL-fit.cnvtools$model.H1$lnL)


###################################################
### chunk number 60: 
###################################################
#line 1007 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
data(SNPTEST)
dim(cases)
dim(controls)


###################################################
### chunk number 61: 
###################################################
#line 1014 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
cases[1:10,1:11]


###################################################
### chunk number 62: 
###################################################
#line 1018 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
cases[1:10,1:11]


###################################################
### chunk number 63: 
###################################################
#line 1023 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
controls[1:10,1:11]


###################################################
### chunk number 64: 
###################################################
#line 1027 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
controls[1:10,1:11]


###################################################
### chunk number 65: 
###################################################
#line 1056 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
nSNP<-nrow(cases)
probs<-lapply(1:nSNP, function(i) {
  snpi.cases<-matrix(as.double(cases[i,6:ncol(cases)]),ncol=3,byrow=TRUE)
  snpi.controls<-matrix(as.double(controls[i,6:ncol(controls)]),ncol=3,byrow=TRUE)
  return(rbind(snpi.cases,snpi.controls))
})


###################################################
### chunk number 66: 
###################################################
#line 1071 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
casecon<-rep(1:0,c(500,500))


###################################################
### chunk number 67: 
###################################################
#line 1077 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
pvals<-multiCNVassoc(probs, formula="casecon~CNV",model="add", num.copies=0:2, cnv.tol=0.001)


###################################################
### chunk number 68: 
###################################################
#line 1082 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
pvalsBH<-getPvalBH(pvals)
head(pvalsBH)


###################################################
### chunk number 69: 
###################################################
#line 1088 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
table(cut(pvalsBH[,2],c(-Inf,1e-3,1e-2,0.05,0.1,Inf)))


###################################################
### chunk number 70: 
###################################################
#line 1126 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
set.seed(123456)
rr<-1.7
incid0<-0.12
lambda<-c(incid0,incid0*rr,incid0*rr^2)
dsim<-simCNVdataPois(n=4000,mu.surrog=0:2,sd.surrog=rep(0.4,3),w=c(0.25,0.5,0.25),lambda=lambda)
head(dsim)


###################################################
### chunk number 71: 
###################################################
#line 1144 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
CNV<-cnv(dsim$surrog,mix="mclust")
CNV


###################################################
### chunk number 72: 
###################################################
#line 1151 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
fit<-CNVassoc(resp~CNV, data=dsim, family="poisson", model="add")
coef(summary(fit))


###################################################
### chunk number 73: 
###################################################
#line 1160 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
fit.gold<-glm(resp~cnv, data=dsim, family="poisson")
table.gold<-c(exp(c(coef(fit.gold)[2],confint(fit.gold)[2,])),coef(summary(fit.gold))[2,4])
names(table.gold)<-c("RR","lower","upper","p-value")
table.gold


###################################################
### chunk number 74: 
###################################################
#line 1174 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
fit.naive<-glm(resp~CNV, data=dsim, family="poisson")
table.naive<-c(exp(c(coef(fit.naive)[2],confint(fit.naive)[2,])),coef(summary(fit.naive))[2,4])
names(table.naive)<-c("RR","lower","upper","p-value")
table.naive


###################################################
### chunk number 75: 
###################################################
#line 1182 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
taula<-rbind(
table.gold[1:3],
coef(summary(fit))[,c("RR","lower.lim","upper.lim")],
table.naive[1:3])
rownames(taula)<-c("Gold","LC","Naive")
xtable(taula,"Comparison of RR estimated by the gold standard model, a latent class model (LC) and naive approach",label="table-compare")


###################################################
### chunk number 76: 
###################################################
#line 1224 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
set.seed(123456)
n<-5000
w<-c(0.25,0.5,0.25)
mu.surrog<-0:2
sd.surrog<-rep(0.4,3)
hr<-1.5
incid0<-0.05
lambda<-c(incid0,incid0*hr,incid0*hr^2)
shape<-1
scale <-lambda^(-1/shape)
perc.obs<-0.10
time.cens<-qweibull(perc.obs,mean(shape),mean(scale))
dsim<-simCNVdataWeibull(n, mu.surrog, sd.surrog, w, lambda, shape, time.cens)
head(dsim)


###################################################
### chunk number 77: 
###################################################
#line 1252 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
CNV<-cnv(dsim$surrog,mix="mclust")
CNV


###################################################
### chunk number 78: 
###################################################
#line 1261 "d:/Rcompile/CRANpkg/local/2.12/CNVassoc/inst/doc/CNVassoc_vignette.Rnw"
fit<-CNVassoc(Surv(resp,cens)~CNV, data=dsim, family="weibull", model="add")
coef(summary(fit))


